/**
 * 
 */
package jp.hrtdotnet.fw;

import jp.hrtdotnet.java.HTestCase;

public class HExceptionResourcesTest extends HTestCase {

    private HExceptionResources resources = new HExceptionResources(this.getClass().getName());

    
    
    /* ( Javadoc)
     * @see junit.framework.TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
    }

    /* ( Javadoc)
     * @see junit.framework.TestCase#tearDown()
     */
    protected void tearDown() throws Exception {
        super.tearDown();
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#getString(java.lang.String)} ̂߂̃eXgE\bhB
     */
    public void testGetStringString() {
        assertEquals("eXgP", resources.getString("test1"));
        assertEquals(HExceptionResources.DEFAULT_MESSAGE, resources.getString("not-exists"));
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#ExceptionResources(java.lang.String)} ̂߂̃eXgE\bhB
     */
    public void testExceptionResources() {
        //sv
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#getString(java.lang.Class, java.lang.String, java.lang.String)} ̂߂̃eXgE\bhB
     */
    public void testGetStringClassStringString() {
        assertEquals("eXgQ", resources.getString(this.getClass(),"test2","L[݂ȂbZ[W"));
        assertEquals("L[݂ȂbZ[W", resources.getString(this.getClass(),"not-exists","L[݂ȂbZ[W"));
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#getString(java.lang.Class, java.lang.String)} ̂߂̃eXgE\bhB
     */
    public void testGetStringClassString() {
        assertEquals("eXgR", resources.getString(this.getClass(),"test3"));
        assertEquals(HExceptionResources.DEFAULT_MESSAGE, resources.getString(this.getClass(),"not-exists"));
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#getString(java.lang.String, java.lang.String)} ̂߂̃eXgE\bhB
     */
    public void testGetStringStringString() {
        assertEquals("eXgS", resources.getString("test4","L[݂ȂbZ[W"));
        assertEquals("L[݂ȂbZ[W", resources.getString("not-exists","L[݂ȂbZ[W"));
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#getString(java.lang.Class, int, java.lang.String)} ̂߂̃eXgE\bhB
     */
    public void testGetStringClassIntString() {
        assertEquals("eXgT", resources.getString(this.getClass(),5,"L[݂ȂbZ[W"));
        assertEquals("L[݂ȂbZ[W", resources.getString(this.getClass(),-1,"L[݂ȂbZ[W"));
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#getString(java.lang.Class, int)} ̂߂̃eXgE\bhB
     */
    public void testGetStringClassInt() {
        assertEquals("eXgU", resources.getString(this.getClass(),6));
        assertEquals(HExceptionResources.DEFAULT_MESSAGE, resources.getString(this.getClass(),-1));
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#getString(int, java.lang.String)} ̂߂̃eXgE\bhB
     */
    public void testGetStringIntString() {
        assertEquals("eXgV", resources.getString(7,"L[݂ȂbZ[W"));
        assertEquals("L[݂ȂbZ[W", resources.getString(-1,"L[݂ȂbZ[W"));
    }

    /**
     * {@link jp.hrtdotnet.fw.HExceptionResources#getString(int)} ̂߂̃eXgE\bhB
     */
    public void testGetStringInt() {
        assertEquals("eXgW", resources.getString(8));
        assertEquals(HExceptionResources.DEFAULT_MESSAGE, resources.getString(-1));
    }

}
